# coding: utf-8

"""
    Robust Intelligence REST API

    API methods for Robust Intelligence. Users must authenticate using the `rime-api-key` header.  # noqa: E501

    OpenAPI spec version: 1.0
    Contact: dev@robustintelligence.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DatasetIdPredictionBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'project_id': 'object',
        'model_id': 'object',
        'metadata': 'RegistryMetadata',
        'integration_id': 'RimeUUID',
        'pred_info': 'RegistryPredInfo',
        'skip_validation': 'bool',
        'agent_id': 'RimeUUID'
    }

    attribute_map = {
        'project_id': 'projectId',
        'model_id': 'modelId',
        'metadata': 'metadata',
        'integration_id': 'integrationId',
        'pred_info': 'predInfo',
        'skip_validation': 'skipValidation',
        'agent_id': 'agentId'
    }

    def __init__(self, project_id=None, model_id=None, metadata=None, integration_id=None, pred_info=None, skip_validation=None, agent_id=None):  # noqa: E501
        """DatasetIdPredictionBody - a model defined in Swagger"""  # noqa: E501
        self._project_id = None
        self._model_id = None
        self._metadata = None
        self._integration_id = None
        self._pred_info = None
        self._skip_validation = None
        self._agent_id = None
        self.discriminator = None
        if project_id is not None:
            self.project_id = project_id
        if model_id is not None:
            self.model_id = model_id
        if metadata is not None:
            self.metadata = metadata
        if integration_id is not None:
            self.integration_id = integration_id
        if pred_info is not None:
            self.pred_info = pred_info
        if skip_validation is not None:
            self.skip_validation = skip_validation
        if agent_id is not None:
            self.agent_id = agent_id

    @property
    def project_id(self):
        """Gets the project_id of this DatasetIdPredictionBody.  # noqa: E501

        Uniquely specifies a Project.  # noqa: E501

        :return: The project_id of this DatasetIdPredictionBody.  # noqa: E501
        :rtype: object
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this DatasetIdPredictionBody.

        Uniquely specifies a Project.  # noqa: E501

        :param project_id: The project_id of this DatasetIdPredictionBody.  # noqa: E501
        :type: object
        """

        self._project_id = project_id

    @property
    def model_id(self):
        """Gets the model_id of this DatasetIdPredictionBody.  # noqa: E501

        Uniquely specifies a Model.  # noqa: E501

        :return: The model_id of this DatasetIdPredictionBody.  # noqa: E501
        :rtype: object
        """
        return self._model_id

    @model_id.setter
    def model_id(self, model_id):
        """Sets the model_id of this DatasetIdPredictionBody.

        Uniquely specifies a Model.  # noqa: E501

        :param model_id: The model_id of this DatasetIdPredictionBody.  # noqa: E501
        :type: object
        """

        self._model_id = model_id

    @property
    def metadata(self):
        """Gets the metadata of this DatasetIdPredictionBody.  # noqa: E501


        :return: The metadata of this DatasetIdPredictionBody.  # noqa: E501
        :rtype: RegistryMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this DatasetIdPredictionBody.


        :param metadata: The metadata of this DatasetIdPredictionBody.  # noqa: E501
        :type: RegistryMetadata
        """

        self._metadata = metadata

    @property
    def integration_id(self):
        """Gets the integration_id of this DatasetIdPredictionBody.  # noqa: E501


        :return: The integration_id of this DatasetIdPredictionBody.  # noqa: E501
        :rtype: RimeUUID
        """
        return self._integration_id

    @integration_id.setter
    def integration_id(self, integration_id):
        """Sets the integration_id of this DatasetIdPredictionBody.


        :param integration_id: The integration_id of this DatasetIdPredictionBody.  # noqa: E501
        :type: RimeUUID
        """

        self._integration_id = integration_id

    @property
    def pred_info(self):
        """Gets the pred_info of this DatasetIdPredictionBody.  # noqa: E501


        :return: The pred_info of this DatasetIdPredictionBody.  # noqa: E501
        :rtype: RegistryPredInfo
        """
        return self._pred_info

    @pred_info.setter
    def pred_info(self, pred_info):
        """Sets the pred_info of this DatasetIdPredictionBody.


        :param pred_info: The pred_info of this DatasetIdPredictionBody.  # noqa: E501
        :type: RegistryPredInfo
        """

        self._pred_info = pred_info

    @property
    def skip_validation(self):
        """Gets the skip_validation of this DatasetIdPredictionBody.  # noqa: E501

        Whether or not to validate the predictions you are registering. Validation ensures that the predictions are valid for Robust Intelligence's systems.  # noqa: E501

        :return: The skip_validation of this DatasetIdPredictionBody.  # noqa: E501
        :rtype: bool
        """
        return self._skip_validation

    @skip_validation.setter
    def skip_validation(self, skip_validation):
        """Sets the skip_validation of this DatasetIdPredictionBody.

        Whether or not to validate the predictions you are registering. Validation ensures that the predictions are valid for Robust Intelligence's systems.  # noqa: E501

        :param skip_validation: The skip_validation of this DatasetIdPredictionBody.  # noqa: E501
        :type: bool
        """

        self._skip_validation = skip_validation

    @property
    def agent_id(self):
        """Gets the agent_id of this DatasetIdPredictionBody.  # noqa: E501


        :return: The agent_id of this DatasetIdPredictionBody.  # noqa: E501
        :rtype: RimeUUID
        """
        return self._agent_id

    @agent_id.setter
    def agent_id(self, agent_id):
        """Sets the agent_id of this DatasetIdPredictionBody.


        :param agent_id: The agent_id of this DatasetIdPredictionBody.  # noqa: E501
        :type: RimeUUID
        """

        self._agent_id = agent_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DatasetIdPredictionBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DatasetIdPredictionBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
