# coding: utf-8

"""
    Robust Intelligence REST API

    API methods for Robust Intelligence. Users must authenticate using the `rime-api-key` header.  # noqa: E501

    OpenAPI spec version: 1.0
    Contact: dev@robustintelligence.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RimeImageReference(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'reference_type': 'ImageReferenceReferenceType'
    }

    attribute_map = {
        'name': 'name',
        'reference_type': 'referenceType'
    }

    def __init__(self, name=None, reference_type=None):  # noqa: E501
        """RimeImageReference - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._reference_type = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if reference_type is not None:
            self.reference_type = reference_type

    @property
    def name(self):
        """Gets the name of this RimeImageReference.  # noqa: E501

        Name of the image being referenced. For a managed image, this is the `name` record of the `ManagedImage` object. For an external image, this is the full name of that image.  # noqa: E501

        :return: The name of this RimeImageReference.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this RimeImageReference.

        Name of the image being referenced. For a managed image, this is the `name` record of the `ManagedImage` object. For an external image, this is the full name of that image.  # noqa: E501

        :param name: The name of this RimeImageReference.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def reference_type(self):
        """Gets the reference_type of this RimeImageReference.  # noqa: E501


        :return: The reference_type of this RimeImageReference.  # noqa: E501
        :rtype: ImageReferenceReferenceType
        """
        return self._reference_type

    @reference_type.setter
    def reference_type(self, reference_type):
        """Sets the reference_type of this RimeImageReference.


        :param reference_type: The reference_type of this RimeImageReference.  # noqa: E501
        :type: ImageReferenceReferenceType
        """

        self._reference_type = reference_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RimeImageReference, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RimeImageReference):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
